// CalculatorError3 - das CalculatorError-Programm, nachdem das
//                    fehlende 'break' hinzugefgt wurde
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

void printErr(int nLN, char cOperator, int nOp1, int nOp2)
{
    cout << "In Zeile " << nLN
         << ": \'" << cOperator
         << "\' Operand 1 = " << nOp1
         << " und Operand 2 = " << nOp2
         << endl;
}


// Prototyp-Deklarationen
int calculator(char cOperator, int nOper1, int nOper2);

int main(int nNumberofArgs, char* pszArgs[])
{
    // Eingabe von operand1 op operand2
    int  nOper1;
    int  nOper2;
    char cOperator;
    cout << "Eingabe von 'wert1 op wert2'\n"
         << "mit op gleich +, -, *, / oder %:" << endl;
    cin >> nOper1 >> cOperator >> nOper2;

    // Ausgabe der Benutzereingaben, gefolgt vom
    // Ergebnis der Operation
    cout << nOper1 << " "
         << cOperator << " "
         << nOper2 << " = "
         << calculator(cOperator, nOper1, nOper2)
         << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fr Weiter..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}

// calculator - Rckgabe des Ergebnisses der cOperator-
//             Operation fr nOper1 und nOper2
int calculator(char cOperator, int nOper1, int nOper2)
{
    printErr(__LINE__, cOperator, nOper1, nOper2);
    int nResult = 0;
    switch (cOperator)
    {
        case '+':
            printErr(__LINE__, cOperator, nOper1, nOper2);
            nResult = nOper1 + nOper2;
            break;
        case '-':
            printErr(__LINE__, cOperator, nOper1, nOper2);
            nResult = nOper1 - nOper2;
            break;
        case '*':
        case 'x':
        case 'X':
            printErr(__LINE__, cOperator, nOper1, nOper2);
            nResult = nOper1 * nOper2;
            break;
        case '/':
            printErr(__LINE__, cOperator, nOper1, nOper2);
            nResult = nOper1 / nOper2;
            break;
        case '%':
            printErr(__LINE__, cOperator, nOper1, nOper2);
            nResult = nOper1 % nOper2;
            break;
        default:
            // Operator wurde nicht verstanden
            cout << " wurde nicht verstanden";
    }
    return nResult;
}
