//
//  ConcatenateError3 - diese Version korrigiert beide
//                      Fehler aus ConcatenateError1.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
using namespace std;


// concatenateString - verknpft zwei Zeichenketten in einem auf
//                     dem Stapel reservierten Array
char* concatenateString(const char* pszSrc1,
                        const char* pszSrc2)
{
    // reserviert ein Array ausreichender Lnge
    int nTargetSize = strlen(pszSrc1)+strlen(pszSrc2)+1;
    char* pszTarget = new char[nTargetSize];
    char* pszT = pszTarget;  // speichert einen Zeiger fr die Rckgabe

    // zuerst die erste Zeichenkette in das Ziel kopieren
    while(*pszSrc1 != '\0')
    {
        *pszTarget++ = *pszSrc1++;
    }

    // jetzt den Inhalt der zweiten Zeichenkette
    // am Ende der zweiten anfgen
    while(*pszSrc2 != '\0')
    {
        *pszTarget++ = *pszSrc2++;
    }

    // terminierende NULL anfgen
    *pszTarget = '\0';

    // unvernderten Zeiger an den Anrufer zurckgeben
    return pszT;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // Benutzer zur Eingabe auffordern
    cout << "Dieses Programm nimmt zwei Zeichenketten\n"
         << "von der Tastatur entgegen und gibt sie\n"
         << "verknpft aus.\n" << endl;

    // zwei Zeichenketten eingeben
    cout << "Eingabe der ersten Zeichenkette: ";
    char szString1[256];
    cin.getline(szString1, 256);

    cout << "Eingabe der zweiten Zeichenkette: ";
    char szString2[256];
    cin.getline(szString2, 256);

    // jetzt den einen am Ende des anderen anfgen
    cout << "Erste Zeichenkette mit der zweiten verknpfen"
         << endl;
    char* pszT = concatenateString(szString1, szString2);

    // und das Ergebnis anzeigen
    cout << "Ergebnis: <"
         << pszT
         << ">" << endl;

    // den Speicher an den Stapel zurckgeben
    delete pszT;
    pszT = nullptr;

    /// Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
