//
//  EarlyBinding - demonstriert die frhe Bindung, indem er eine
//                 Elementfunktion mit einer anderen in einer
//                 Unterklasse berschreibt.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

class Student
{
  public:
    double calcTuition() { return 0.0; }
};

class GraduateStudent : public Student
{
  public:
    double calcTuition() { return 1.0; }
};

int main(int nNumberofArgs, char* pszArgs[])
{
    // hier wird Student::calcTuition() aufgerufen
    Student s;
    cout << "Der Wert von s.calcTuition() ist "
         << s.calcTuition()
         << endl;

    // hier wird GraduateStudent::calcTuition() aufgerufen
    GraduateStudent gs;
    cout << "Der Wert von gs.calcTuition() ist "
         << gs.calcTuition()
         << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
