//
//  FactorialFunction - Umschreiben des Fakultt-Codes als
//                separate Funktion.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

//
// factorial - gibt die Fakultt des bergebenen Arguments zurck.
//             Gibt 1 fr ungltige Argumente zurck, wie
//             beispielsweise negative Zahlen.
int factorial(int nTarget)
{
    // Beginn mit einem Akkumulator, der mit 1 initialisiert wird
    int nAccumulator = 1;
    for (int nValue = 1; nValue <= nTarget; nValue++)
    {
        nAccumulator *= nValue;
    }

    return nAccumulator;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    cout << "Dieses Programm berechnet Fakultten"
         << " der Benutzereingabe.\n"
         << "Beenden mit einer negativen Zahl" << endl;

    // in einer Schleife die Eingabe vom Benutzer entgegennehmen,
    // bis er eine negative Zahl eingibt
    for (;;)
    {
        // Eingabe der Zahl fr die Berechnung der Fakultt
        int nValue;

        cout << "Eingabe der Zahl: ";
        cin  >> nValue;

        // Beenden, wenn die Zahl negativ ist
        if (nValue < 0)
        {
            break;
        }

        // das Ergebnis anzeigen
        int nFactorial = factorial(nValue);
        cout << nValue << " Fakultt ist "
             << nFactorial << endl;
    }

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
