//
//  FactorialModule - Fakultt-Code als separate Funktion
//                in ihrem eigenen Modul.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

#include "factorial.h"

int main(int nNumberofArgs, char* pszArgs[])
{
    cout << "Dieses Programm berechnet Fakultten"
         << " fr die Benutzereingabe.\n"
         << "Beenden mit einer negativen Zahl" << endl;

    // in einer Schleife Eingaben vom Benutzer entgegennehmen,
    // bis er eine negative Zahl eingibt
    for (;;)
    {
        // Eingabe der Zahl, fr die die Fakultt berechnet werden soll
        int nValue;

        cout << "Eingabe der Zahl: ";
        cin  >> nValue;

        // Beenden, wenn die Zahl negativ ist
        if (nValue < 0)
        {
            break;
        }

        // das Ergebnis anzeigen
        int nFactorial = factorial(nValue);
        cout << nValue << " Fakultt ist "
             << nFactorial << endl;
    }

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
