//
//  ForFactorial - Berechnung der Fakultt in einem for-Konstrukt.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

int main(int nNumberofArgs, char* pszArgs[])
{
    cout << "Dieses Programm berechnet Fakultten fr die Benutzereingabe.\n"
         << "Beenden mit einer negativen Zahl\n";

    while(true)
    {
        // Eingabe der Zahl, deren Fakultt berechnet werden soll
        int nTarget;
        cout << "Eingabe einer Zahl fr die Berechnung der Fakultt: ";
        cin  >> nTarget;

        // Abbruch, wenn die eingegebene Zahl negativ ist
        if (nTarget < 0)
        {
            break;
        }

        // Beginn mit einem Akkumulator, der mit 1 initialisiert wird
        int nAccumulator = 1;
        for(int nValue = 1; nValue <= nTarget; nValue++)
        {
            cout << nAccumulator << " * "
                 << nValue << " ist gleich ";
            nAccumulator = nAccumulator * nValue;
            cout << nAccumulator << endl;
        }

        // Anzeige des Ergebnisses
        cout << nTarget << " Fakultt ist "
             << nAccumulator << endl;
    }

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}

