//
//  StudentDestructor - dieses Programm demonstriert die Verwendung
//               des Destruktors, um die vom Konstruktor reservierten
//               Ressourcen zurckzugeben
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

class Student
{
  protected:
    double* pdGrades;
    int*    pnHours;

  public:
    // Konstruktor - den Studenten mit einem zulssigen Status initialisieren
    Student()
    {
        cout << "Konstruktion eines Student-Objekts" << endl;
        pdGrades = new double[128];
        pnHours  = new int[128];
    }
   ~Student()
    {
        cout << "Zerstren eines Student-Objekts" << endl;
        delete[] pdGrades;
        pdGrades = nullptr;

        delete[] pnHours;
        pnHours = nullptr;
    }
};

Student* fn()
{
    cout << "Eintritt in fn()" << endl;

    // Erstellen eines Studenten un dinitialisieren
    cout << "Den Studenten s erstellen" << endl;
    Student s;

    // ein Array mit Studenten erzeugen
    cout << "Ein Array mit 5 Studenten erzeugen" << endl;
    Student sArray[5];

    // jetzt einen auf dem Stapel reservieren
    cout << "Einen Studenten auf dem Stapel reservieren" << endl;
    Student *pS = new Student;

    cout << "Rckgabe von fn()" << endl;
    return pS;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // jetzt einen auf dem Stapel reservieren
    Student *pS = fn();

    // den von fn() zurckgegebenen Zeiger lschen
    cout << "Den von fn() zurckgegebenen Zeiger lschen"
         << endl;
    delete pS;
    pS = nullptr;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
