//
//  TutorPairDestructor - dieses Programm demonstriert, wie
//          Datenelemente automatisch zerstrt werden
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

class Student
{
  protected:
    double dGrade;         // GPA des Studenten
    int    nSemesterHours;

  public:
    // Konstruktor - den Studenten in einem zulssigen Status initialisieren
    Student()
    {
        cout << "Ein Student-Objekt konstruieren" << endl;
        dGrade = 0.0;
        nSemesterHours = 0;
    }
   ~Student()
    {
        cout << "Ein Student-Objekt zerstren" << endl;
    }
};

class Teacher
{
  public:
    // Konstruktor - den Student in einem zulssigen Status initialisieren
    Teacher()
    {
        cout << "Ein Teacher-Objekt konstruieren" << endl;
    }
   ~Teacher()
    {
        cout << "Ein Teacher-Objekt zerstren" << endl;
    }
};

class TutorPair
{
  protected:
    Student s;
    Teacher t;

    int nNumberOfMeetings;

  public:
    TutorPair()
    {
        cout << "Konstruktion der TutorPair-Elemente"
             << endl;
        nNumberOfMeetings = 0;
    }
   ~TutorPair()
    {
        cout << "Zerstren des TutorPair-Objekts"
             << endl;
    }
};

void fn()
{
    // ein TutorPair erzeugen und initialisieren
    cout << "Das TutorPair tp erzeugen" << endl;
    TutorPair tp;

    cout << "Rckgabe aus fn()" << endl;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    fn();

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
