//
//  AmbiguousBindng - Demonstriert einen Fall, in dem nicht
//                    kar ist, was passieren sollte. In diesem
//                    Fall verwendet C++ eine frhe Bindung,
//                    whrend Sprachen wie Java und C#
//                    eine Spte Bindung verwenden.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

class Student
{
  public:
    double calcTuition() { return 0.0; }
};

class GraduateStudent : public Student
{
  public:
    double calcTuition() { return 1.0; }
};

double someFn(Student* pS)
{
    return pS->calcTuition();
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // nachfolgend wird Student::calcTuition() aufgerufen
    Student s;
    cout << "Der Wert von someFn(&s) ist "
         << someFn(&s)
         << endl;

    // nachfolgend wird GraduateStudent::calcTuition() aufgerufen
    GraduateStudent gs;
    cout << "Der Wert von someFn(&gs) ist "
         << someFn(&gs)
         << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fr Weiter..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
