//
//  ArrayDemo - demonstriert die Verwendung eines Arrays
//              zur Aufnahme mehrerer Zahlen
//
#include <cstdio>
#include <cstdlib>
#include <iostream>

using namespace std;

// displayArray - zeigt den Inhalt des gefllten Arrays
//                der Lnge nCount an
void displayArray(int nValues[100], int nCount)
{
    for(int i = 0; i < nCount; i++)
    {
        cout.width(3);
        cout << i << " - " << nValues[i] << endl;
    }
}

// averageArray - mittelt den Inhalt des gefllten Arrays
//                der Lnge nCount
int averageArray(int nValues[100], int nCount)
{
    int nSum = 0;
    for(int i = 0; i < nCount; i++)
    {
        nSum += nValues[i];
    }
    return nSum / nCount;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    int nScores[100];
    int nCount;

    // fordert den Benutzer zur Eingabe auf
    cout << "Dieses Programm erstellt den Mittelwert einer Menge von Noten\n"
         << "Geben Sie die zu mittelnden Noten ein\n"
         << "(mit einer negativen Zahl wird die Eingabe beendet)"
         << endl;
    for(nCount = 0; nCount < 100; nCount++)
    {
        cout << "Weiter: ";
        cin >> nScores[nCount];
        if (nScores[nCount] < 0)
        {
            break;
        }
    }

    // jetzt die Ergebnisse ausgeben
    cout << "Eingabe beendet." << endl;
    cout << "Eingabedaten:" << endl;
    displayArray(nScores, nCount);
    cout << "Der Mittelwert ist "
         << averageArray(nScores, nCount)
         << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fr Weiter..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
