// CalculatorError3 - das CalculatorError-Programm, dem das fehlende
//                    'break' hinzugefgt wurde.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

// Prototyp-Deklarationen
int calculator(char cOperator, int nOper1, int nOper2);

int main(int nNumberofArgs, char* pszArgs[])
{
    // Eingabe von operand1 op operand2
    int  nOper1;
    int  nOper2;
    char cOperator;
    cout << "Eingabe von 'wert1 op wert2'\n"
         << "mit op gleich +, -, *, / oder %:" << endl;
    cin >> nOper1 >> cOperator >> nOper2;

    // Ausgabe der Benutzereingaben, gefolgt von den
    // Ergebnissen der Operation
    cout << nOper1 << " "
         << cOperator << " "
         << nOper2 << " = "
         << calculator(cOperator, nOper1, nOper2)
         << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fr Weiter..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}

// calculator -Rckgabe des Ergebnisses der cOperator-
//             Operation fr nOper1 und nOper2
//             (Bei einer Division durch Null, oder wenn
//             der Operator nicht verstanden wird, gibt die
//             Funktion 0 zurck.)
int calculator(char cOperator, int nOper1, int nOper2)
{
    int nResult = 0;
    switch (cOperator)
    {
        case '+':
            nResult = nOper1 + nOper2;
            break;
        case '-':
            nResult = nOper1 - nOper2;
            break;
        case '*':
        case 'x':
        case 'X':
            nResult = nOper1 * nOper2;
            break;
        case '/':
            if (nOper2 != 0)
            {
                nResult = nOper1 / nOper2;
            }
            break;
        case '%':
            nResult = nOper1 % nOper2;
            break;
        default:
            // der Operator wurde nicht verstanden
            cout << " wurde nicht verstanden";
    }
    return nResult;
}
