//
//  ConcatenateNString - hnlich wie ConcatenateString, auer
//                 dass diese Version sicherstellt, dass nicht
//                 ber das Ende des Zielarrays hinausgeschrieben
//                 wird
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;


// concatenateString - fgt eine Zeichenkette am Ende der
//                     anderen an (nicht ber
//                     nTargetSize hinausschreiben)
void concatenateString(char szTarget[],
                       int  nTargetSize,
                 const char szSource[])
{
    // zuerst das Ende der Zielzeichenkette finden
    int nT;
    for(nT = 0; szTarget[nT] != '\0'; nT++)
    {
    }

    // jetzt den Inhalt der Quellzeichenkette in
    // die Zielzeichenkette kopieren, beginnend bei 'nT', aber
    // nicht ber das nTargetSize. Element hinaus (- 1, um
    // Platz fr die terminierende NULL zu halten)
    for(int nS = 0;
           nT < (nTargetSize - 1) && szSource[nS] != '\0';
              nT++, nS++)
    {
        szTarget[nT] = szSource[nS];
    }

    // Abschluss fr szTarget hinzufgen
    szTarget[nT] = '\0';
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // Benutzer zur Eingabe auffordern
    cout << "Dieses Programm nimmt zwei Zeichenketten\n"
         << "von der Tastatur entgegen und gibt sie\n"
         << "verknpft aus.\n" << endl;

    // Eingabe von zwei Zeichenketten
    cout << "Geben Sie die erste Zeichenkette ein: ";
    char szString1[256];
    cin.getline(szString1, 256);

    cout << "Geben Sie die zweite Zeichenkette ein: ";
    char szString2[256];
    cin.getline(szString2, 256);

    // jetzt eine am Ende der anderen anfgen
    cout << "Die erste Zeichenkette an die zweite anfgen"
         << endl;
    concatenateString(szString1, 256, szString2);

    // und das Ergebnis anzeigen
    cout << "Ergebnis: <"
         << szString1
         << ">" << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;
    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
