//
//  ConcatenateError1 - hnlich ConcatenatePtr, auer dass diese
//                    Version mehrere Fehler enthlt, die
//                    mit dem Debugger ganz einfach zu
//                    finden sind
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
using namespace std;


// concatenateString - zwei Zeichenketten in einem auf dem Stapel
//                     reservierten Array verknpfen
char* concatenateString(const char* pszSrc1,
                        const char* pszSrc2)
{
    // ein Array ausreichender Lnge reservieren
    int nTargetSize = strlen(pszSrc1)+strlen(pszSrc2)+1;
    char* pszTarget = new char[nTargetSize];

    // zuerst die erste Zeichenkette in das Ziel kopieren
    while(*pszSrc1 != '\0')
    {
        *pszTarget++ = *pszSrc1++;
    }

    // jetzt den Inhalt der zweiten Zeichenkette an das
    // Ende der ersten anfgen
    while(*pszSrc2 != '\0')
    {
        *pszTarget++ = *pszSrc2++;
    }

    // die resultierende Zeichenkette an den Aufrufer zurckgeben
    return pszTarget;
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // Benutzer zur Eingabe auffordern
    cout << "Dieses Programm nimmt zwei Zeichenketten\n"
         << "von der Tastatur entgegen und gibt sie\n"
         << "verknpft wieder aus.\n" << endl;

    // Eingabe von zwei Zeichenketten
    cout << "Eingabe der ersten Zeichenkette: ";
    char szString1[256];
    cin.getline(szString1, 256);

    cout << "Eingabe der zweiten Zeichenkette: ";
    char szString2[256];
    cin.getline(szString2, 256);

    // jetzt eine am Ende der anderen anfgen
    cout << "Die erste Zeichenkette mit der zweiten verknpfen"
         << endl;
    char* pszT = concatenateString(szString1, szString2);

    // und das Ergebnis anzeigen
    cout << "Ergebnis: <"
         << pszT
         << ">" << endl;

    // Rckgabe des Speichers an den Stapel
    delete pszT;
    pszT = nullptr;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
