//
//  ConcatenateString - demonstriert die Manipulation von
//                ASCIIZ-Zeichenketten durch die Implementierung einer
//                Kontatenierungsfunktion
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;


// concatenateString - konkateniert eine Zeichenkette am
//                     Ende einer anderen
void concatenateString(char szTarget[],
                 const char szSource[])
{
    // zuerst das Ende der Zielzeichenkette finden
    int nT;
    for(nT = 0; szTarget[nT] != '\0'; nT++)
    {
    }

    // jetzt den Inhalt der Quellzeichenkette in die
    // Zielzeichenkette kopieren, beginnend bei 'nT'
    for(int nS = 0; szSource[nS] != '\0'; nT++, nS++)
    {
        szTarget[nT] = szSource[nS];
    }

    // Abschluss an szTarget anfgen
    szTarget[nT] = '\0';
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // Benutzer zur Eingabe auffordern
    cout << "Dieses Programm nimmt zwei Zeichenketten\n"
         << "von der Tastatur entgegen und gibt sie\n"
         << "verknpft aus.\n" << endl;

    // zwei Zeichenketten eingeben
    cout << "Geben Sie die erste Zeichenkette ein: ";
    char szString1[256];
    cin.getline(szString1, 256);

    cout << "Geben Sie die zweite Zeichenkette ein: ";
    char szString2[256];
    cin.getline(szString2, 256);

    // jetzt eine am Ende der anderen anfgen
    cout << "Die erste Zeichenkette mit der zweiten verknpfen"
         << endl;
    concatenateString(szString1, szString2);

    // und das Ergebnis anzeigen
    cout << "Ergebnis: <"
         << szString1
         << ">" << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
