//
//  DisplayASCIIZ - Anzeige einer ASCIIZ-Zeichenkette in einzelnen Zeichen
//                  als Beispiel fr eine ASCIIZ-Manipulation
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;


// displayString - zeigt eine ASCIIZ-Zeichenkette zeichenweise an
void displayString(char szString[])
{
    for(int index = 0; szString[index] != '\0'; index++)
    {
        cout << szString[index];
    }
}

int main(int nNumberofArgs, char* pszArgs[])
{
    char szName1[] = {'S', 't', 'e', 'p',
                      'h', 'e', 'n', '\0'};
    char szName2[] = "Stephen";

    cout << "Ausgabe szName1: ";
    displayString(szName1);
    cout << endl;

    cout << "Ausgabe szName2: ";
    displayString(szName2);
    cout << endl;


    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
