//
//  LateBinding - durch das Schlsselwort 'virtual'
//                wechselt C++ von der frhen Bindungzur spten
//                Binding.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

class Student
{
  public:
    virtual double calcTuition() { return 0.0; }
};

class GraduateStudent : public Student
{
  public:
    virtual double calcTuition() { return 1.0; }
};

double someFn(Student* pS)
{
    return pS->calcTuition();
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // Folgendes ruft Student::calcTuition() auf
    Student s;
    cout << "Der Wert von someFn(&s) ist "
         << someFn(&s)
         << endl;

    // Folgendes ruft GraduateStudent::calcTuition() auf
    GraduateStudent gs;
    cout << "Der Wert von someFn(&gs) ist "
         << someFn(&gs)
         << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
