//
//  SavingsAccount - dieses Programm implementiert eine einfache
//                   Sparkonto-Klasse
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <cstring>
using namespace std;


// Savings - eine einfache Sparkontoklasse
class Savings
{
  public:
    int    nAccountNumber;
    double dBalance;

    // deposit - einen Betrag auf das Konto einzahlen
    //           Einzahlungen mssen positiv sein; den resultierenden
    //           Kontostand oder 0 zurckgeben
    double deposit(double dAmount)
    {
        // keine negativen Einzahlungen - das ist eine Abhebung
        if (dAmount < 0)
        {
            return 0.0;
        }

        // okay - zum Kontostand addieren und die Summe zurckgeben
        dBalance += dAmount;
        return dBalance;
    }

    // withdraw - eine Abhebung ausfhren, wenn gengend Geld
    //            zur Verfgung steht
    double withdraw(double dAmount)
    {
        if (dBalance < dAmount)
        {
            return 0.0;
        }

        dBalance -= dAmount;
        return dBalance;
    }
};

int main(int nNumberofArgs, char* pszArgs[])
{
    Savings s = {0, 0.0};

    // zuerst als Wert bergeben
    someFunc(s);

    // jetzt die Adresse bergeben
    someFunc(&s);

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann

    system("PAUSE");
    return 0;
}
