//
//  ToUpper - wandelt eine eingegebene Zeichenkette in
//            Grossbuchstaben um.
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;


// toUpper - wandelt jedes Zeichen in einer ASCIIZ-Zeichenkette
//           in Grossbuchstaben um
void toUpper(char szTarget[], int  nTargetSize)
{
    for(int nT = 0;
           nT < (nTargetSize - 1) && szTarget[nT] != '\0';
              nT++)
    {
        szTarget[nT] = toupper(szTarget[nT]);
    }
}

int main(int nNumberofArgs, char* pszArgs[])
{
    // Prompt user
    cout << "Dieses Programm nimmt eine Zeichenkette\n"
         << "von der Tastatur entgegen und gibt die\n"
         << "Zeichenkette in Grossbuchstaben aus.\n" << endl;

    // Eingabe von zwei Zeichenketten
    cout << "Eingabe einer Zeichenkette: ";
    char szString[256];
    cin.getline(szString, 256);

    // jetzt die Zeichenkette in Grossbuchstaben umwandeln
    toUpper(szString, 256);

    // und das Ergebnis anzeigen
    cout << "Version in Grossbuchstaben: <"
         << szString
         << ">" << endl;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
