//
//  TutorPairConstructor - dieses Programm demonstriert, wie
//          Datenelemente automatisch konstruiert werden
//
#include <cstdio>
#include <cstdlib>
#include <iostream>
using namespace std;

class Student
{
  protected:
    double dGrade;         // GPA des Studenten
    int    nSemesterHours;

  public:
    // constructor - den Studenten mit einem zulssigen Status initialisieren
    Student()
    {
        cout << "Konstruktion eines Student-Objekts" << endl;
        dGrade = 0.0;
        nSemesterHours = 0;
    }
};

class Teacher
{
  public:
    // Konstruktor - den Student in einem zulssigen Status initialisieren
    Teacher()
    {
        cout << "Konstruktion eines Teacher-Objekts" << endl;
    }
};

class TutorPair
{
  protected:
    Student s;
    Teacher t;

    int nNumberOfMeetings;

  public:
    TutorPair()
    {
        cout << "Die TutorPair-Elemente konstruieren"
             << endl;
        nNumberOfMeetings = 0;
    }
};

int main(int nNumberofArgs, char* pszArgs[])
{
    // ein TutorPair erzeugen und initialisieren
    cout << "Das TutorPair tp erzeugen" << endl;
    TutorPair tp;

    // Warten, bis der Benutzer bereit ist, bevor das Programm
    // beendet wird, sodass der Benutzer die Programmergebnisse
    // sehen kann
    cout << "Eingabetaste fuer Weiter..." << endl;

    cin.ignore(10, '\n');
    cin.get();
    return 0;
}
